#include "testlib.h"

#include <string>
#include <vector>
#include <iostream>
#include <cassert>
#include <algorithm>

using namespace std;

const int MIN_TEMP = 0;
const int MAX_TEMP = 1000 * 1000 * 1000;

void chain(int a, int b, int c, int len, bool low_mode, vector<int> &days, vector<pair<int, int>> &jackets) {
	assert(len >= 3);
	assert(a < b && b < c);
	if (low_mode) {
		days.push_back(a);
		int posc = rnd.next(0, len-3);
		for (int i = 0; i < len - 2; ++i) {
			if (i == posc) {
				days.push_back(c);
			} else {
				days.push_back(b);
			}
		}
		days.push_back(a);
		jackets.push_back({a, c});
		jackets.push_back({b, c});
		jackets.push_back({c, c});
	} else {
		days.push_back(c);
		int posa = rnd.next(0, len-3);
		for (int i = 0; i < len - 2; ++i) {
			if (i == posa) {
				days.push_back(a);
			} else {
				days.push_back(b);
			}
		}
		days.push_back(c);
		jackets.push_back({a, a});
		jackets.push_back({a, b});
		jackets.push_back({a, c});
	}
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int chlen = atoi(argv[2]);
	vector<int> days;
	vector<pair<int, int>> jackets;

	vector<int> temps(n);
	for (int i = 0; i < n; ++i) temps[i] = rnd.next(MIN_TEMP, MAX_TEMP - n);
	sort(temps.begin(), temps.end());
	for (int i = 0; i < n; ++i) temps[i] += i;

	vector<int> iperm(n / chlen);
	for (int i = 0; i < iperm.size(); ++i) iperm[i] = i;
	shuffle(iperm.begin(), iperm.end());

	int newn = 0;
	for (int i = 0; newn + chlen <= n; ++i) {
		chain(temps[3*iperm[i]], temps[3*iperm[i]+1], temps[3*iperm[i]+2], chlen, rnd.next(0, 1), days, jackets);
		newn += chlen;
	}
	n = newn;

	shuffle(jackets.begin(), jackets.end());
	
	int m = jackets.size();

	cout << n << " " << m << endl;
	for (int i = 0; i < n; ++i) {
		if (i) cout << " ";
		cout << days[i];
	}
	cout << endl;
	for (int i = 0; i < m; ++i) {
		cout << jackets[i].first << " " << jackets[i].second << endl;
	}
}
