#include <cstdio>
#include <set>
#include <cassert>

using namespace std;

const int MAXN = 100100;

int cnt[MAXN];
int ids[MAXN][3];
int ok[MAXN][3];

void restore(int n, int id) {
  if (n == 0) {
    printf("%d", ids[n][id] + 1);
    return;
  }
  for (int j = 0; j < cnt[n-1]; j++)
    if (ok[n-1][j] && ids[n-1][j] != ids[n][id]) {
      restore(n - 1, j);
      printf(" %d", ids[n][id] + 1);
      return;
    }
  assert(0);
}

int main() {
  int n, m;
  scanf("%d%d", &n, &m);
  set<pair<int, int>> s;
  for (int i = 0; i < n; i++) {
    int a;
    scanf("%d", &a);
    s.insert({a, i});
  }
  for (int i = 0; i < m; i++) {
    int l, r;
    scanf("%d%d", &l, &r);
    auto it = s.lower_bound({l, -1});
    while (it != s.end() && it->first <= r) {
      auto nit = it;
      nit++;
      int id = it->second;
      ids[id][cnt[id]++] = i;
      if (cnt[id] == 3) s.erase(it);
      it = nit;
    }
  }

  for (int i = 0; i < cnt[0]; i++) {
    ok[0][i] = 1;
  }
  for (int i = 1; i < n; i++) {
    for (int j = 0; j < cnt[i-1]; j++) 
      for (int k = 0; k < cnt[i]; k++) {
        if (ids[i-1][j] != ids[i][k] && ok[i-1][j]) {
          ok[i][k] = 1;
        }
      }
  }

  for (int i = 0; i < cnt[n-1]; i++) {
    if (ok[n-1][i]) {
      printf("Yes\n");
      restore(n-1, i);
      printf("\n");
      return 0;
    }
  }
  printf("No\n");
  return 0;
}
